% kickSpeed -> duration
% data = [ 7.5, 10;
%          7.2, 9;
%          7.0, 8;
%          6.6, 7;
%          5.7, 6;
%          4.75, 5;
%          3.7, 4;
%          2.75, 3;
%          1.55, 2;
%          0.3, 1;
%          3.35, 3.5;
%          2.25, 2.5;
%          1, 1.5;
%          4.2, 4.5;
%          5.45, 5.5;
%          6.5, 6.5;
%          7.0, 7.5;
%          7.2, 8.5;
%          7.45, 9.5];

% old straight
data = [8.1, 10;
        7.9, 8;
        7.5, 7;
        7.8, 6;
        7.4, 5;
        6.3, 4;
        4.9, 3;
        3.1, 2;
        1.3, 1;
        6.6, 4.5;
        5.7, 3.5;
        4.1, 2.5;
        2.3, 1.5];
       
% chip new
data = [168, 10; 
        160, 9; 
        157, 8; 
        153, 7; 
        140, 6; 
        120, 5.5
        90, 5;
        70, 5;
        100, 4.5;
        70, 4.5;
        68, 4.5;
        70, 4; 
        40, 3; 
        10, 2];
      
data = [2, 0.06;
        2.5, 0.06;
        3, 0.15;
        3.5, 0.28;
        4.0, 0.45;
        4.5, 0.65;
        5.0, 0.96;
        5.5, 1.17;
        6.0, 1.27;
        6.5, 1.42;
        7.0, 1.70;
        7.5, 1.70;
        8.0, 1.84;
        8.5, 1.86;
        9.0, 1.91;
        9.5, 1.95;
        10, 1.83;
        12, 1.98;
        9, 1.88;
        8, 2.0;
        7, 1.64;
        6, 1.44;
        5, 0.90;
        4, 0.35;
        4.5, 0.70;
        5.5, 1.10;
        6.5, 1.50;
        7.5, 2.10;
        7.5, 2.0;
        7.0, 1.66;
        7.0, 1.98;
  ];
data = [data(:,2), data(:,1)];

% chip old dist -> duration
% data = [10, 3;
%         100, 4;
%         110, 4;
%         55, 3.5;
%         70, 3.5;
%         95, 4.5;
%         140, 5;
%         150, 5.5;
%         160, 6;
%         185, 7;
%         160, 8;
%         175, 9;
%         180, 10];

% chip v2016 series
data = [2, 0.06;
        2.5, 0.06;
        3, 0.15;
        3.5, 0.28;
        4.0, 0.45;
        4.5, 0.65;
        5.0, 0.96;
        5.5, 1.17;
        6.0, 1.27;
        6.5, 1.42;
        7.0, 1.70;
        7.5, 1.70;
        8.0, 1.84;
        8.5, 1.86;
        9.0, 1.91;
        9.5, 1.95;
        10, 1.83;
        12, 1.98;
        9, 1.88;
        8, 2.0;
        7, 1.64;
        6, 1.44;
        5, 0.90;
        4, 0.35;
        4.5, 0.70;
        5.5, 1.10;
        6.5, 1.50;
        7.5, 2.10;
        7.5, 2.0;
        7.0, 1.66;
        7.0, 1.98;
  ];
data = [data(:,2), data(:,1)];

% chip?
beta = 45*pi/180;
data(:,1) = sqrt((data(:,1)*9.81)/sin(2*beta));
       
offset = 8;

data2 = data(data(:,2)<offset,:);

% yData = [1500;3000;5000;6000];
% xData = [300;2500;3500;4500];
xData = data2(:,1);
yData = data2(:,2);

% Set up fittype and options.
ft = fittype( 'poly1' );

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft );

p1=fitresult.p1;
p2=fitresult.p2;
% x=0:0.1:10;
x=0:1:200;

f = @(x) (p1 * x + p2);

close all
figure
plot(data(:,1),data(:,2),'*');
hold all;
% plot(x,f(x));
plot(fitresult)
xlabel('kick speed m/s');
ylabel('duration');

fitresult