/*
 * *********************************************************
 * Copyright (c) 2009 - 2011, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - Sumatra
 * Date: 07.12.2011
 * Author(s): Gero
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.sumatra.view.referee;

import edu.tigers.sumatra.Referee.SSL_Referee.Command;
import edu.tigers.sumatra.math.IVector2;


/**
 * Listens on events generated by the gui
 * 
 * @author Gero
 */
public interface ICreateRefereeMsgObserver
{
	/**
	 * Called by the gui when the "send" btn is pressed
	 * 
	 * @param cmd
	 * @param goalsBlue
	 * @param goalsYellow
	 * @param timeLeft
	 * @param timestamp
	 * @param placementPos
	 */
	void onSendOwnRefereeMsg(Command cmd, int goalsBlue, int goalsYellow, short timeLeft, long timestamp,
			IVector2 placementPos);
			
			
	/**
	 * Should we receive external referee cmds?
	 * 
	 * @param receive
	 */
	void onEnableReceive(boolean receive);
}
